<?php

namespace OrganizationsManagement\Api\ContractedModules\Repositories;

use Doctrine\DBAL\Exception;
use OrganizationsManagement\Repository\RepositoryBase;
use OrganizationsManagement\Util\InstanceProvider;

class OmProduto extends RepositoryBase
{
    const ENTITY_NAME = '\Teknisa\Model\Teknisa\Entities\OmProduto';

    public function __construct()
    {
        parent::__construct(self::ENTITY_NAME);
    }

    /**
     * @param $nrorg
     * @param $productId
     * @return array[]
     * @throws Exception
     */
    public function findModules($nrorg, $productId, $filterDtValidade = 'N'): array
    {
        $dtValidadeFilter = "";
        if($filterDtValidade == 'S') {
            $dtValidadeFilter = "AND (TRUNC(OE.DTVALIDADE) >= TRUNC(SYSDATE) OR OE.DTVALIDADE IS NULL)";
        }
        $query = "
            SELECT DISTINCT PE.NREXTERNAL_PRODUCT_ID AS ID
              FROM OM_PRODUTO_ORG_ELEMENTO OE
              JOIN OM_PRODUTO_ORG PO ON PO.ID = OE.NRPRODUTO_ORG_ID
              JOIN OM_PRODUTO_ELEMENTO PE ON PE.ID = OE.NRPRODUTO_ELEMENTO_ID
              JOIN OM_PRODUTO OP ON OP.ID = PO.NRPRODUTO_ID
             WHERE OP.NREXTERNAL_PRODUCT_ID = :PRODUCT_ID
               AND PO.NRORG_ID = :NRORG
               $dtValidadeFilter
        ";

        $params = array(
            'PRODUCT_ID' => $productId,
            'NRORG' => $nrorg,
        );

        return $this->entityManager->getConnection()->fetchAllAssociative($query, $params);
    }
}
