<?php
namespace OrganizationsManagement\Controller;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource;
use OrganizationsManagement\Service;
use OrganizationsManagement\Util\Instance;
use OrganizationsManagement\Util\Messages;
use OrganizationsManagement\Util\Utilities;

class CRMIntegration extends Simple
{

    public function getClassificationRelationship(DTO\Request\Filter $request, DTO\Response $response){
        try {
            $page     = $request->getFilterCriteria()->getPage();
            $pageSize = $request->getFilterCriteria()->getPageSize();
            $filters  = $request->getFilterCriteria()->getConditions();
            $classificationRelationship = Instance\Service::getCRMIntegration()->getClassificationRelationship($page, $pageSize, $filters);
            Utilities::setDataSetDefault($request,$response,$classificationRelationship);
        } catch(\Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
    public function getClassificationGep(DTO\Request\Filter $request, DTO\Response $response){
        try {
            $page     = $request->getFilterCriteria()->getPage();
            $pageSize = $request->getFilterCriteria()->getPageSize();
            $filters  = $request->getFilterCriteria()->getConditions();
            $classificationGep = Instance\Service::getCRMIntegration()->getClassificationGep($page, $pageSize, $filters);
            Utilities::setDataSetDefault($request,$response,$classificationGep);
        } catch(\Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }

    public function getClassificationPM(DTO\Request\Filter $request, DTO\Response $response){
        try {
            $page     = $request->getFilterCriteria()->getPage();
            $pageSize = $request->getFilterCriteria()->getPageSize();
            $filters  = $request->getFilterCriteria()->getConditions();
            $classificationPM = Instance\Service::getCRMIntegration()->getClassificationPM($page, $pageSize, $filters);
            Utilities::setDataSetDefault($request,$response,$classificationPM);
        } catch(\Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }

    public function classificationRelationshipSave(DTO\Request\DataSet $request, DTO\Response $response){
        try {
            $row = $request->getDataSet()->getRows()[0];
            $cdmoticont = $row['CDMOTICONT'];
            $classificationId = $row['CLASSIFICATION_ID'];
            $cdassunto = $row['CDASSUNTO'];
            $cdmoticont = Instance\Service::getCRMIntegration()->classificationRelationshipSave($cdmoticont,$cdassunto,$classificationId);
            Utilities::setDataSetDefault($request,$response,array(array('CDMOTICONT'=>$cdmoticont)));
        } catch(\Exception $ex) {
            $response->addMessage(new DTO\Response\Message($ex->getMessage()));
            $response->setError(new DTO\Response\Error($ex->getMessage(), $ex->getCode()));
        }
    }
}